import React, {useState }  from 'react';
import logo from './logo.svg';
import './App.css';
import {Provider, connect}   from 'react-redux';
import {actionSearch } from './actions';
import store from './reducers'
//import { CounterView, Counter, ConnectedBIGTABLO, ConnectedCounter, ConnectedBigButton } from './components'
import {Router, Route, Link, Switch, Redirect} from 'react-router-dom';
import createHistory from "history/createBrowserHistory";

import {actionPosts, actionLogin} from './actions'


const history = createHistory()

const Post = ({post}) =>
<div>
    <h2>{post.title}</h2>
    <p>{post.text}</p>
</div>

const PostFeed = ({posts=[]}) =>
<div>
    {posts && posts.map(p => <Post post={p}/>)}
</div>

const CPostFeed = connect(s => ({posts:s.promise.posts && 
                                       s.promise.posts.payload && 
                                       s.promise.posts.payload.getPosts}))(PostFeed)

const PageMain = () =>
<>
    <CPostFeed />
</>

const LoginForm = ({onLogin}) => {
    const [login, setLogin] = useState("")
    const [password, setPassword] = useState("")
    return (
            <div>
                <input type='text' value={login} onChange={e => setLogin(e.target.value)} />
                <input type='password' value={password} onChange={e => setPassword(e.target.value)} />
                <button onClick={() => onLogin(login, password)}>Login</button>
            </div>
        )
}
const CLoginForm = connect(null, {onLogin: actionLogin})(LoginForm)


store.dispatch(actionPosts())

export default () => {
    return (
        <Provider store={store}>
            <CLoginForm />
            <Router history={history}>
                <Route path="/" component={PageMain} />
            </Router>
        </Provider>
    )
}
